﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using static System.Windows.Forms.VisualStyles.VisualStyleElement;

namespace _15AlgSortKubelkowy
{
    struct Kubelek
    {
        public List<Int32> t;
    }
    public partial class Form1 : Form
    {
        //dane będa przechowywane w liście a nie w tablicy
        List<Kubelek> lista=new List<Kubelek>();
        int rozmiar;
 
        Int32[] tab;
        void losujTablice(Int32[] t, int zakres)
        {
            Random r = new Random();
            int i = 0;
            //mogą występować powtórzenia wylosowanych elementów
            while (i < t.Length)
            {
                t[i] = r.Next(zakres) + 1;
                i++;
            }
        }

        void sortKubelkowy(Int32[] t,List<Kubelek> lis,int roz)
        {
            //zkares kubełków ustaw na max liczbę podzieloną przez
            //ilośc liczb które będą sortowane
            int z = 1000000000 / roz;
            //przygotuj kubełki
            for (int i = 0; i < roz; i++) {
                Kubelek k = new Kubelek();
                k.t= new List<Int32>();
                lis.Add(k);
            }
            //przenies liczby do odpowiedniego kubełka
            for (int i = 0; i < roz; i++)
                lis[t[i] / z].t.Add(t[i]);
            //sortuj w kubełkach
            //gdy w kubełku są co najmniej 2 liczby
            for (int i = 0; i < roz; i++)
                if (lis[i].t.Count > 1) lis[i].t.Sort();
        }
        void sortKubelkowy2(Int32[] t, List<Kubelek> lis, int max) 
        {
            //odczytaj rozmiar zbioru
            int roz=t.GetLength(0);
            // max to przewidywana maksymalna wartośc przechowywana w zbiorze
            // przygotuj kubełki
            for (int i = 0; i < max+1; i++)
            {
                Kubelek k = new Kubelek();
                k.t = new List<Int32>();
                lis.Add(k);
            }
            //przenies liczby do odpowiedniego kubełka
            for (int i = 0; i < roz; i++)
                lis[t[i]].t.Add(t[i]);
            //przenies liczby z kubelkow do tablicy
            int jj = 0;
            for (int i = 0; i < lis.Count; i++)
                for (int j = 0; j < lista[i].t.Count; j++)
                {
                    t[jj] = lista[i].t[j];
                    jj++;
                }
        }

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //losowanie nowej tablicy
            if (textBox1.Text.Length < 1) return;
            //wyczysc stary zbiór
            lista.Clear();
            //ustaw nowy rozmiar
            rozmiar = int.Parse(textBox1.Text);
            if (tab != null) Array.Clear(tab, 0, tab.Length);
            tab = new int[rozmiar];
            //przy losowaniu ustaw zakres na 2 razy większy od rozmiaru
            losujTablice(tab, 2 * rozmiar);
            //pokaz wylosowany zbior
            textBox2.Clear();
            for (int i = 0; i < tab.Length; i++)
                textBox2.AppendText(tab[i].ToString() + Environment.NewLine);
        }

        private void textBox1_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 8) return;//wyskocz jak BackSpace
            if (e.KeyChar < '0' || e.KeyChar > '9') e.Handled = true;//ignoru nienumeryczne
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (tab == null) return;
            lista.Clear();
            sortKubelkowy(tab, lista, rozmiar);
            textBox3.Clear();
            //wypisz posortowany zbiór
            for (int i=0;i<rozmiar;i++)
              for(int j = 0; j < lista[i].t.Count;j++)
                    textBox3.AppendText(lista[i].t[j].ToString() + Environment.NewLine);
        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (tab == null) return;
            int max = int.Parse(textBox4.Text);
            lista.Clear();
            sortKubelkowy2(tab, lista, max);
            textBox3.Clear();
            //wypisz posortowany zbiór
            for (int i = 0; i < tab.Length; i++)
                textBox3.AppendText(tab[i].ToString() + Environment.NewLine);
        }
    }
}
